/* jdwang@asia.edu.tw
 * 2016.12.3 For Parse TDCS_M06A	UȦ|l
 * qƻ`䴩t (Traffic Data Collection System,TDCS) 
 * http://tisvcloud.freeway.gov.tw/
 */
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Job;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.hadoop.mapreduce.Reducer;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;
import org.apache.hadoop.io.IntWritable;

public class TDCS_GIDSequence_MRE_24Hour {

	public static void main(String[] args) throws Exception {
		Configuration conf = new Configuration();
		
		boolean useResourceManager = true;
		if(useResourceManager)
		{
			conf.set("fs.defaultFS", "hdfs://0.0.0.0:9000");
			conf.set("mapreduce.framework.name", "yarn");
			//conf.set("yarn.nodemanager.aux-services","mapreduce_shuffle");
			//conf.set("yarn.resourcemanager.hostname", "0.0.0.0");
			//conf.set("yarn.nodemanager.hostname", "0.0.0.0");		
		}
		else
		{
			conf.set("fs.defaultFS", "file:///");
			conf.set("mapreduce.framework.name", "local");
			//conf.set("yarn.resourcemanager.address", "localhost");
			conf.set("hadoop.tmp.dir", "/windoop/tmp/hadoop-${user.name}");
		}
		
		Job job = Job.getInstance(conf, "TDCS_GIDSequence_MRE");
				
		job.setJarByClass(TDCS_GIDSequence_MRE_24Hour.class);
		// TODO: specify a mapper
		//job.setMapperClass(Mapper_TDCS_VehicleType.class);
		//job.setMapperClass(Mapper_TDCS_GIDSequence_MRE_24Hour.class);
		job.setMapperClass(Mapper_TDCS_GIDSequence_MRE_24Hour_SpecificGantryID.class);
		
		
		
		job.setMapOutputKeyClass(Text.class);    
	    job.setMapOutputValueClass(IntWritable.class); 
		
		// TODO: specify a reducer
		job.setReducerClass(Reducer_TDCS_GIDSequence_MRE_24Hour.class);

		// TODO: specify output types
		job.setOutputKeyClass(Text.class);
		job.setOutputValueClass(IntWritable.class);

		// TODO: specify input and output DIRECTORIES (not files)
		
		//FileInputFormat.setInputPaths(job, new Path("input_TDCS"));
		FileInputFormat.setInputPaths(job, new Path("input_TDCS_24Hour"));
		
		FileSystem hdfs = FileSystem.get(conf);	    	    
		//Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+ "output_VehicleType");
		//Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+ "output_GantryID");
		//Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+ "output_VehicleType_24Hour");
		Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+ "output_GantryID_24Hour_03F1860S");

		FileOutputFormat.setOutputPath(job, outputPath);
	    
	    if(hdfs.exists(outputPath)) { 
	    	hdfs.delete(outputPath, true);
	    } 
	    hdfs.close();
		
	    job.submit();
	   
		if(job.waitForCompletion(true))
	  	{
	  		System.out.println("Job Done!");
	  		System.exit(0);
	  	}
	  	else
	  	{
	  		System.out.println("Job Failed!");
	  		System.exit(1);
	  	}    
	}
}
